This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Move tests for use for "new style version numbers" to use.t from require.t
[perl5.git] / t / comp / use.t
1 #!./perl
2
3 BEGIN {
4     chdir 't' if -d 't';
5     @INC = ('../lib', 'lib');
6     $INC{"feature.pm"} = 1; # so we don't attempt to load feature.pm
7 }
8
9 print "1..70\n";
10
11 # Can't require test.pl, as we're testing the use/require mechanism here.
12
13 my $test = 1;
14
15 sub _ok {
16     my ($type, $got, $expected, $name) = @_;
17
18     my $result;
19     if ($type eq 'is') {
20         $result = $got eq $expected;
21     } elsif ($type eq 'isnt') {
22         $result = $got ne $expected;
23     } elsif ($type eq 'like') {
24         $result = $got =~ $expected;
25     } else {
26         die "Unexpected type '$type'$name";
27     }
28     if ($result) {
29         if ($name) {
30             print "ok $test - $name\n";
31         } else {
32             print "ok $test\n";
33         }
34     } else {
35         if ($name) {
36             print "not ok $test - $name\n";
37         } else {
38             print "not ok $test\n";
39         }
40         my @caller = caller(1);
41         print "# Failed test at $caller[1] line $caller[2]\n";
42         print "# Got      '$got'\n";
43         if ($type eq 'is') {
44             print "# Expected '$expected'\n";
45         } elsif ($type eq 'isnt') {
46             print "# Expected not '$expected'\n";
47         } elsif ($type eq 'like') {
48             print "# Expected $expected\n";
49         }
50     }
51     $test = $test + 1;
52     $result;
53 }
54
55 sub like ($$;$) {
56     _ok ('like', @_);
57 }
58 sub is ($$;$) {
59     _ok ('is', @_);
60 }
61 sub isnt ($$;$) {
62     _ok ('isnt', @_);
63 }
64
65 # new style version numbers
66
67 eval q{ use v5.5.630; };
68 is ($@, '');
69
70 eval q{ use 10.0.2; };
71 like ($@, qr/^Perl v10\.0\.2 required/);
72
73 eval "use 5.000";       # implicit semicolon
74 is ($@, '');
75
76 eval "use 5.000;";
77 is ($@, '');
78
79 eval "use 6.000;";
80 like ($@, qr/Perl v6\.0\.0 required--this is only \Q$^V\E, stopped/);
81
82 eval "no 6.000;";
83 is ($@, '');
84
85 eval "no 5.000;";
86 like ($@, qr/Perls since v5\.0\.0 too modern--this is \Q$^V\E, stopped/);
87
88 eval "use 5.6;";
89 like ($@, qr/Perl v5\.600\.0 required \(did you mean v5\.6\.0\?\)--this is only \Q$^V\E, stopped/);
90
91 eval "use 5.8;";
92 like ($@, qr/Perl v5\.800\.0 required \(did you mean v5\.8\.0\?\)--this is only \Q$^V\E, stopped/);
93
94 eval "use 5.9;";
95 like ($@, qr/Perl v5\.900\.0 required \(did you mean v5\.9\.0\?\)--this is only \Q$^V\E, stopped/);
96
97 eval "use 5.10;";
98 like ($@, qr/Perl v5\.100\.0 required \(did you mean v5\.10\.0\?\)--this is only \Q$^V\E, stopped/);
99
100 eval "use 5.11;";
101 like ($@, qr/Perl v5\.110\.0 required \(did you mean v5\.11\.0\?\)--this is only \Q$^V\E, stopped/);
102
103 eval sprintf "use %.6f;", $];
104 is ($@, '');
105
106
107 eval sprintf "use %.6f;", $] - 0.000001;
108 is ($@, '');
109
110 eval sprintf("use %.6f;", $] + 1);
111 like ($@, qr/Perl v6.\d+.\d+ required--this is only \Q$^V\E, stopped/);
112
113 eval sprintf "use %.6f;", $] + 0.00001;
114 like ($@, qr/Perl v5.\d+.\d+ required--this is only \Q$^V\E, stopped/);
115
116 # check that "use 5.11.0" (and higher) loads strictures
117 eval 'use 5.11.0; ${"foo"} = "bar";';
118 like ($@, qr/Can't use string \("foo"\) as a SCALAR ref while "strict refs" in use/);
119 # but that they can be disabled
120 eval 'use 5.11.0; no strict "refs"; ${"foo"} = "bar";';
121 is ($@, "");
122 # and they are properly scoped
123 eval '{use 5.11.0;} ${"foo"} = "bar";';
124 is ($@, "");
125 # and this doesn't happen with require
126 eval 'require 5.11.0; ${"foo"} = "bar";';
127 is ($@, "");
128
129 { use test_use }        # check that subparse saves pending tokens
130
131 local $test_use::VERSION = 1.0;
132
133 eval "use test_use 0.9";
134 is ($@, '');
135
136 eval "use test_use 1.0";
137 is ($@, '');
138
139 eval "use test_use 1.01";
140 isnt ($@, '');
141
142 eval "use test_use 0.9 qw(fred)";
143 is ($@, '');
144
145 is("@test_use::got", "fred");
146
147 eval "use test_use 1.0 qw(joe)";
148 is ($@, '');
149
150 is("@test_use::got", "joe");
151
152 eval "use test_use 1.01 qw(freda)";
153 isnt($@, '');
154
155 is("@test_use::got", "joe");
156
157 {
158     local $test_use::VERSION = 35.36;
159     eval "use test_use v33.55";
160     is ($@, '');
161
162     eval "use test_use v100.105";
163     like ($@, qr/test_use version v100.105.0 required--this is only version v35\.360\.0/);
164
165     eval "use test_use 33.55";
166     is ($@, '');
167
168     eval "use test_use 100.105";
169     like ($@, qr/test_use version 100.105 required--this is only version 35.36/);
170
171     local $test_use::VERSION = '35.36';
172     eval "use test_use v33.55";
173     like ($@, '');
174
175     eval "use test_use v100.105";
176     like ($@, qr/test_use version v100.105.0 required--this is only version v35\.360\.0/);
177
178     eval "use test_use 33.55";
179     is ($@, '');
180
181     eval "use test_use 100.105";
182     like ($@, qr/test_use version 100.105 required--this is only version 35.36/);
183
184     local $test_use::VERSION = v35.36;
185     eval "use test_use v33.55";
186     is ($@, '');
187
188     eval "use test_use v100.105";
189     like ($@, qr/test_use version v100.105.0 required--this is only version v35\.36\.0/);
190
191     eval "use test_use 33.55";
192     is ($@, '');
193
194     eval "use test_use 100.105";
195     like ($@, qr/test_use version 100.105 required--this is only version v35.36/);
196 }
197
198
199 {
200     # Regression test for patch 14937: 
201     #   Check that a .pm file with no package or VERSION doesn't core.
202     # (git commit 2658f4d9934aba5f8b23afcc078dc12b3a40223)
203     eval "use test_use_14937 3";
204     like ($@, qr/^test_use_14937 defines neither package nor VERSION--version check failed at/);
205 }
206
207 my @ver = split /\./, sprintf "%vd", $^V;
208
209 foreach my $index (-3..+3) {
210     foreach my $v (0, 1) {
211         my @parts = @ver;
212         if ($index) {
213             if ($index < 0) {
214                 # Jiggle one of the parts down
215                 --$parts[-$index - 1];
216                 if ($parts[-$index - 1] < 0) {
217                     # perl's version number ends with '.0'
218                     $parts[-$index - 1] = 0;
219                     $parts[-$index - 2] -= 2;
220                 }
221             } else {
222                 # Jiggle one of the parts up
223                 ++$parts[$index - 1];
224             }
225         }
226         my $v_version = sprintf "v%d.%d.%d", @parts;
227         my $version;
228         if ($v) {
229             $version = $v_version;
230         } else {
231             $version = $parts[0] + $parts[1] / 1000 + $parts[2] / 1000000;
232         }
233
234         eval "use $version";
235         if ($index > 0) {
236             # The future
237             like ($@,
238                   qr/Perl $v_version required--this is only \Q$^V\E, stopped/,
239                   "use $version");
240         } else {
241             # The present or past
242             is ($@, '', "use $version");
243         }
244
245         eval "no $version";
246         if ($index <= 0) {
247             # The present or past
248             like ($@,
249                   qr/Perls since $v_version too modern--this is \Q$^V\E, stopped/,
250                   "no $version");
251         } else {
252             # future
253             is ($@, '', "no $version");
254         }
255     }
256 }
257